// Code generated by MockGen. DO NOT EDIT.
// Source: interfaces.go

// Package repository_test is a generated GoMock package.
package grpc

import (
	context "context"
	reflect "reflect"
	domain "user-service/internal/domain"

	gomock "go.uber.org/mock/gomock"
)

// MockUserApp is a mock of UserApp interface.
type MockUserApp struct {
	ctrl     *gomock.Controller
	recorder *MockUserAppMockRecorder
}

// MockUserAppMockRecorder is the mock recorder for MockUserApp.
type MockUserAppMockRecorder struct {
	mock *MockUserApp
}

// NewMockUserApp creates a new mock instance.
func NewMockUserApp(ctrl *gomock.Controller) *MockUserApp {
	mock := &MockUserApp{ctrl: ctrl}
	mock.recorder = &MockUserAppMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use.
func (m *MockUserApp) EXPECT() *MockUserAppMockRecorder {
	return m.recorder
}

// Add mocks base method.
func (m *MockUserApp) Add(ctx context.Context, user domain.UserAttrs) (domain.UserId, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "Add", ctx, user)
	ret0, _ := ret[0].(domain.UserId)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// Add indicates an expected call of Add.
func (mr *MockUserAppMockRecorder) Add(ctx, user interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Add", reflect.TypeOf((*MockUserApp)(nil).Add), ctx, user)
}

// GetUsers mocks base method.
func (m *MockUserApp) GetUsers(ctx context.Context, cr domain.UserCriteria) ([]domain.User, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "GetUsers", ctx, cr)
	ret0, _ := ret[0].([]domain.User)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// GetUsers indicates an expected call of GetUsers.
func (mr *MockUserAppMockRecorder) GetUsers(ctx, cr interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GetUsers", reflect.TypeOf((*MockUserApp)(nil).GetUsers), ctx, cr)
}

// Notify mocks base method.
func (m *MockUserApp) Notify(ctx context.Context, notification domain.UserNotification) error {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "Notify", ctx, notification)
	ret0, _ := ret[0].(error)
	return ret0
}

// Notify indicates an expected call of Notify.
func (mr *MockUserAppMockRecorder) Notify(ctx, notification interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Notify", reflect.TypeOf((*MockUserApp)(nil).Notify), ctx, notification)
}

// ReadNotifications mocks base method.
func (m *MockUserApp) ReadNotifications() (<-chan domain.UserNotification, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "ReadNotifications")
	ret0, _ := ret[0].(<-chan domain.UserNotification)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// ReadNotifications indicates an expected call of ReadNotifications.
func (mr *MockUserAppMockRecorder) ReadNotifications() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "ReadNotifications", reflect.TypeOf((*MockUserApp)(nil).ReadNotifications))
}

// RemoveUser mocks base method.
func (m *MockUserApp) RemoveUser(ctx context.Context, userId domain.UserId) error {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "RemoveUser", ctx, userId)
	ret0, _ := ret[0].(error)
	return ret0
}

// RemoveUser indicates an expected call of RemoveUser.
func (mr *MockUserAppMockRecorder) RemoveUser(ctx, userId interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "RemoveUser", reflect.TypeOf((*MockUserApp)(nil).RemoveUser), ctx, userId)
}

// UpdateUser mocks base method.
func (m *MockUserApp) UpdateUser(ctx context.Context, userId domain.UserId, attrs domain.UserAttrs) error {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "UpdateUser", ctx, userId, attrs)
	ret0, _ := ret[0].(error)
	return ret0
}

// UpdateUser indicates an expected call of UpdateUser.
func (mr *MockUserAppMockRecorder) UpdateUser(ctx, userId, attrs interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "UpdateUser", reflect.TypeOf((*MockUserApp)(nil).UpdateUser), ctx, userId, attrs)
}
